// packageA//pages/chongzhi/chongzhi.js
const app = getApp();
var util = require('../../../utils/util.js');

Page({

  /**
   * 页面的初始数据
   */
  data: {
		url: app.globalData.setting.imghost,
		imgAd: '',
		ad_color:'',
		
		currentIndex: 0,
		list: null,
		
		// 检测是否已经发送请求,防止重复发送请求
		isLoading: false,
		// 检测是否有更多数据,true为没有更多数据,false为还有数据
		noMore: false,
		// 当前页数
		pageNum: 1,
		
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
		

		var self = this;
				
		this.getData(true,'/api/weshop/users/pageNewVIPAddMoney',{
			store_id: app.globalData.userInfo.store_id,
			user_id: app.globalData.userInfo.user_id,
			IsPos: 0,
		});	
		
		app.request.get('/api/weshop/ad/page', {
		  data: {
				pid: 611,
				store_id: app.globalData.userInfo.store_id,
				enabled: 1,
			},
		  success: function (res) {
				// console.log('604',res.data.data[0].ad_code);
				if(res.data.code==0  &&  res.data.data.pageData  &&  res.data.data.pageData.length>0 ){
					var a = res.data.data.pageData;
					self.setData({
						imgAd: a[0].ad_code,
						ad_color: a[0].bgcolor,
					});
				}
				
				
		  },
		});
  },

 
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
      getApp().check_can_share();
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
			console.log('上拉加载');
			var data = this.data.saveData;
			// 数据总量
			var total = this.data.result.total;
			// 单页最大数据量
			var pageSize = this.data.result.pageSize;
			
			if((total !== 0)&&(total <= pageSize)) {
				this.setData({
					noMore: true
				});
			};
			
			if(!this.data.isLoading && !this.data.noMore) {
				this.setData({
					isLoading: true,
					pageNum: this.data.pageNum + 1
				});
				
				data.page = this.data.pageNum;
				
				this.getData(false,'/api/weshop/users/pageNewVIPAddMoney',data);
			};
  },

  /**
   * 用户点击右上角分享
   */
   onShareAppMessage: function () {   	  getApp().globalData.no_clear=1

  },
	
	
	onClickTab(e) {
		var data = {
			store_id: app.globalData.userInfo.store_id,
			user_id: app.globalData.userInfo.user_id,
			page: 1,
		};
		
		this.setData({
			currentIndex: e.target.dataset.index,
			list: [],
		});
		
		if(e.target.dataset.index == 0) {
			data.IsPos = 0;
			
		} else {
			data.IsPos = 1;
			
			this.setData({
				saveData: data
			});
		}		
		this.getData(true,'/api/weshop/users/pageNewVIPAddMoney',data);	
	},
	
	
	// 请求数据
	getData(isInit, url, data, callback) {
		var self = this;
		// 请求数据
		app.request.get(url, {
		  data: data,
		  success: function (res) {
				console.log('res-->', res);
		    // 请求成功后,把正在请求加载状态置为false
		    self.setData({
		    	isLoading: false,
		    });
		    // 检测是否是初始化第一次加载
		    if(isInit) {
		    	//第一页数据直接赋值
		    	self.setData({
		    		list: res.data.data.pageData,
		    		// 这里保存了一份完整的响应数据
		    		result: res.data.data,
		    	});
		    } else {
		    	// 下一页的数据拼接在原有数据后面
		    	self.setData({
		    		list: self.data.list.concat(res.data.data.pageData)
		    	});
		    };
		    console.log('result', self.data.list);
		    // 回调函数
		    if(callback) callback();
		    // 1、第一次请求返回的数据为空,显示‘没有更多了’；
		    // 2、后面的请求,如果返回的数据为空,就表示没有下一页了,noMore置为true,这样上拉加载scrollToLower不再发起请求；
		    if((res.data.data.pageData.length === 0) || (res.data.data.total <= res.data.data.pageSize)) {
		    	self.setData({
		    		noMore: true
		    	});
		    };
		  },
		});
	},
	
	
	goDetails(e) {
		let id = e.currentTarget.dataset.id;
		app.goto('../chongzhiDetails/chongzhiDetails?id=' + id+"&type=1");
	},
	
	 viewDetails(e){
		var index=e.currentTarget.dataset.index;
		//var WriteOffCode=this.data.list[index].WriteOffCode;
		var id=this.data.list[index].ID;

		this.detail_next(id);
	},

	async detail_next(id){
	    var code='';
		//获取二维码,强制更新
		let res= await  getApp().request.promisePut("/api/weshop/store/updateErpApi",{
			data:{
				store_id:getApp().globalData.setting.stoid,
				ApiName:"/api/erp/vip/buyaddmoneyactDetails/updateMainCode",
				Id:id,
				VIPId:getApp().globalData.userInfo.erpvipid
			}
		})
		if(res){
			if(res.data.code==-1){
				util.m_toast(res.data.msg);
				return false;
			}
			if(res.data.data)
				code = res.data.data.WriteOffCode;
		}
		if(!code){
			util.m_toast('未找到二维码');
			return false;
		}


		var qrcode = this.selectComponent("#qrcode"); //组件的id
		var e={is_fw:1,val:code,code:code}
		qrcode.open(e);
	},


	// 检测上拉滚动到底部
	// scrollToLower: function (requestData, callback) {
	// 	// 数据总量
	// 	var total = this.data.result.total;
	// 	// 单页最大数据量
	// 	var pageSize = this.data.result.pageSize;
		
	// 	if((total !== 0)&&(total <= pageSize)) {
	// 		this.setData({
	// 			noMore: true
	// 		});
	// 	};
		
	// 	if(!this.data.isLoading && !this.data.noMore) {
	// 		this.setData({
	// 			isLoading: true,
	// 			pageNum: this.data.pageNum + 1
	// 		});
			
	// 		requestData.data.page = this.data.pageNum;
			
	// 		this.getData(false, requestData, callback);
	// 	};
	// },
	
	
	onerror:function(e){
		var _errImg = e.currentTarget.dataset.errimg;		
		var _errObj = {};
		_errObj[_errImg] = "/miniapp/images/default_g_img.gif";
		this.setData(_errObj); 
	}
})